import java.util.LinkedList;
import java.util.NoSuchElementException;

public class ListMap<K, V> {
    private LinkedList<Association<K, V>> items;

    public ListMap() {
        items = new LinkedList<>();
    }

    private Association<K, V> findKey(K key) {
        for (Association<K, V> kvPair : items) {
            if (kvPair.getKey().equals(key)) {
                return kvPair;
            }
        }
        return null;
    }

    public void put(K key, V value) {
        // search for existing key 
        Association<K, V> kvPair = findKey(key);
        if (kvPair != null) {
            // if found, replace the value
            items.remove(kvPair);
            items.add(new Association<>(key, value));
            return;
        }
        // else add a new key-value pair
        items.add(new Association<>(key, value));
    }

    public boolean contains(K key) {
        return findKey(key) != null;
    }

    public V get(K key) {
        Association<K, V> kvPair = findKey(key);
        if (kvPair == null) {
            throw new NoSuchElementException();
        }
        return kvPair.getValue();
    }

    public V remove(K key) {
        Association<K, V> kvPair = findKey(key);
        if (kvPair == null) {
            throw new NoSuchElementException();
        }
        items.remove(kvPair);
        return kvPair.getValue();
    }
}
